<!-- Component to display the task list -->
<template>
  <div>
    <b-table
      :striped="false"
      :bordered="true"
      :borderless="true"
      :outlined="false"
      :small="false"
      :hover="true"
      :dark="false"
      :fixed="true"
      :foot-clone="true"
      :items="items"
      :fields="fields"
      head-variant="dark"
      :table-variant="''"
      tbody-tr-class="my-vertical-align"
      empty-text="Il n'y a pas de tâche à faire"
      show-empty
      responsive="sm"
    >
      <template #cell(title)="data">
        <b class="text-secondary">{{ data.value }}</b>
      </template>
      <template #cell(description)="data">
        <b class="text-secondary">{{ data.value }}</b>
      </template>
      <template #cell(completed)="data">
        <i
          v-if="data.item.completed === undefined || data.item.completed === false"
          class="fas fa-times-circle text-danger"
          style="font-size: 40px;cursor: pointer;vertical-align: middle"
          @click="basculed(data.item,true)"
        />
        <i
          v-if="data.item.completed === true"
          class="fas fa-check-circle text-success"
          style="font-size: 40px;cursor: pointer;vertical-align: middle"
          @click="basculed(data.item,false)"
        />
      </template>
      <template #cell(actions)="data">
        <b-button
          type="submit"
          variant="warning"
          class="m-5px"
          @click="update(data.item)"
        >
          <i class="far fa-edit" />
        </b-button>
        <b-button
          variant="danger"
          class="m-5px"
          @click="onDelete(data.item)"
        >
          <i class="fas fa-trash" />
        </b-button>
      </template>
    </b-table>

    <modal
      :data-to-edit="data_to_edit"
      :show="show_modal_edit"
      @closemodalevent="setShowModal"
      @successevent="updated"
    />

    <dialog-delete
      :data-to-delete="data_to_delete"
      :show="show_modal_delete"
      @cancelevent="setShowModalDelete"
      @okevent="processDelete"
    />
  </div>
</template>

<script>
import Modal from './Modal'
import DialogDelete from './DialogDelete'

export default {
  name: 'DataTable',
  components: {
    Modal, DialogDelete
  },
  props: {
    // eslint-disable-next-line vue/require-valid-default-prop
    items: { type: Array, default: [] },
    // eslint-disable-next-line vue/require-valid-default-prop
    fields: { type: Array, default: [] }
  },
  data () {
    return {
      data_to_edit: null,
      data_to_delete: null,
      show_modal_edit: false,
      show_modal_delete: false
    }
  },
  mounted () {
    // We change the style of the table header
    const theadDarks = document.querySelectorAll('.thead-dark')
    theadDarks.forEach((th) => {
      th.style.backgroundColor = '#212529'
      th.style.color = 'white'
    })
  },
  methods: {
    /**
     * Sends an event to the parent component telling it that it can modify the completed field with respect to the value sent.
     * @param item {Object}
     * @param value {Boolean}
     */
    basculed (item, value) {
      this.$emit('basculedevent', {
        item, value
      })
    },
    /**
     * Allows the item value to be assigned in the data_to_edit variable to be displayed and processed in the modal
     * @param item {Object}
     */
    update (item) {
      this.data_to_edit = item
      this.setShowModal(true)
    },
    /**
     * Sends an event to the parent component to update the selective task
     * @param payload
     */
    updated (payload) {
      this.$emit('updatedevent', payload)
    },
    /**
     * Enables the delete confirmation mode and sets the data_to_delete variable to the value of the selected task
     * @param item {Object}
     */
    onDelete (item) {
      this.data_to_delete = item
      this.setShowModalDelete(true)
    },
    /**
     * Warns the parent component that it may trigger the deletion process of the selected task
     * @param payload {Object}
     */
    processDelete (payload) {
      this.setShowModalDelete(false)
      this.$emit('processdeleteevent', payload)
    },
    /**
     * Display or close the update modal
     * @param payload {Boolean}
     */
    setShowModal (payload) {
      this.show_modal_edit = payload
    },
    /**
     * Display or close the delete modal
     * @param payload {Boolean}
     */
    setShowModalDelete (payload) {
      this.show_modal_delete = payload
    }
  }
}
</script>

<style>

</style>
